package com.clx.performance.sqlProvider;

import cn.hutool.core.util.ObjectUtil;
import com.clx.order.enums.OrderEnum;
import com.clx.performance.model.OrderGoods;
import com.clx.performance.model.OwnerAccount;
import com.clx.performance.param.pc.PageOwnerAccountListParam;
import org.apache.commons.lang3.StringUtils;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.jdbc.SQL;

import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.util.List;

public class OwnerAccountSqlProvider {

    public String pageList(@Param("param") PageOwnerAccountListParam param) {
        String sql = new SQL() {{
            SELECT("a.id, a.owner_user_no," +
                    " a.owner_user_name, a.mobile, a.account_type, " +
                    " a.account_balance,a.usable_balance, a.frozen_balance,a.create_by,a.create_time");
            FROM("owner_account a");


            if (StringUtils.isNotBlank(param.getOwnerUserNo())) {
                WHERE("a.owner_user_no = #{param.ownerUserNo}");
            }
            if (ObjectUtil.isNotNull(param.getMobile())) {
                WHERE("a.mobile = #{param.mobile}");
            }
            if (ObjectUtil.isNotNull(param.getAccountType())) {
                WHERE("a.account_type = #{param.accountType}");
            }
            ORDER_BY("a.create_time desc");
        }}.toString();
        return sql;
    }

    public String updateAccount(OwnerAccount account, LocalDateTime now) {
        StringBuffer sqlList = new StringBuffer();

        sqlList.append("update owner_account set usable_balance = usable_balance +" +
                account.getUsableBalance() + ",frozen_balance = frozen_balance +"
                + account.getUsableBalance() + ",account_balance = account_balance +"
                + account.getAccountBalance()+
                ",modify_time=" + now
                + "where id = " + account.getId() + "and modify_time = " + account.getModifyTime()
        );

        return sqlList.toString();
    }
//
//    public String subAccount(OwnerAccount account, LocalDateTime now) {
//        StringBuffer sqlList = new StringBuffer();
//
//        sqlList.append("update owner_account set usable_balance = usable_balance -" +
//                account.getUsableBalance() + ",frozen_balance = frozen_balance -"
//                + account.getUsableBalance() + ",modify_time=" + now
//                + "where id = " + account.getId() + "and modify_time = " + account.getModifyTime()
//        );
//
//        return sqlList.toString();
//    }
}
